
#include <stdio.h>
#include "sp.h"


/* **********************************************************************

status[v]  indica se o vertice v est na rvore, na orla ou fora

parent[v] contm o vertice que  pai de v na rvore (arco candidato de v)

fringeLink[v] contm a ligao (o nmero do) prximo vrtice da orla

distance[v] contm a distncia da origem a v      (algoritmo SP)

fringeWgt[v] contm o peso do arco candidato de v (algoritmo MST)

********************************************************************** */


// -------------------------------------------------------------------
// Shortest Path (algoritmo de Dijkstra)
void sp(Graph g, int n, int s, int d)       // g com vertices de 1 a n
{
  int status[MAXVERTICES];
  int parent[MAXVERTICES];
  int fringeLink[MAXVERTICES];
  int distance[MAXVERTICES];
  Node *p;         // para atravessar as listas de adjacnci
  int x,y;
  int fringeList;  // o primeiro vrtice da orla
  int stuck;
  int prev;        // auxilar para a remoo dum vrtice da orla


  /* inicializao */
  x = s; 
  fringeList = 0;
  for (y = 1 ; y <= n ; y++) status[y] = UNSEEN;      
  status[s] = INTREE;
  distance[s] = 0;
  stuck = 0;

  while (x!=d && !stuck) {

    /* atravessar lista de adjacncias de x */
    for (p=g[x]; p; p=p->next) {
      y = p->vertex;
      if (status[y]==FRINGE && distance[x]+p->weight < distance[y]) {
	/* substituir arco candidato de y por xy */
           
          .....................................

      }
      else if (status[y]==UNSEEN) {
	/* y est na orla; xy  arco candidato */

          .....................................

      }
    } /* for */

    /* escolher prximo vrtice e arco para a rvore */
    if (fringeList==0) 
      stuck = 1;
    else {

          .....................................

      /* escolher o arco que coloca o n da orla a menor distncia da origem */
          .....................................
      /* remover o arco candidato (x) da orla */
          .....................................

    }
  } /* while */


  /* mostra caminho e distncia */

          .....................................

}




